=== debian/changelog ===
openorienteering-mapper (0.8.1.1-1build1) bionic; urgency=medium

  * No-change rebuild against qtbase-abi-5-9-5.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sat, 14 Apr 2018 22:08:07 -0500

openorienteering-mapper (0.8.1.1-1) unstable; urgency=medium

  [ Gaudenz Steinlin ]
  * New upstream release
    - Fix build on big-endian systems (Closes: #865180)
    - Fix reproducible builds (Closes: #876934)
    - Update for PROJ5
  * Change VCS URLs to salsa.debian.org
  * Document updating to a new upstream release

  [ Graham Inggs ]
  * Add Build-Depends on sqlite3
  * Switch to debhelper compat level 11
  * Skip tests when DEB_BUILD_OPTIONS=nocheck
  * Bump Standards-Version to 4.1.3, no changes

 -- Graham Inggs <ginggs@debian.org>  Thu, 29 Mar 2018 13:49:31 +0000
