=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/openorienteering-mapper-$1\.tar\.gz/ \
  https://github.com/OpenOrienteering/mapper/tags .*/v?(\d\S*)\.tar\.gz
